local _G = GLOBAL
local GI = _G.GI
local TheInputProxy = _G.TheInputProxy
--local TheInput = _G.TheInput
GI.ToggleDown = function ()
    GI.SESSION = GI.MEMORYALL and "MemoryAll" or _G.TheWorld.meta.session_identifier
    GI.Init(GI.SESSION)

    local x0, y0 = TheInputProxy:GetOSCursorPos()
    GI.gim:HideAll()
    GI.breakFlag = false
    GI.UpdataCursor(x0, y0, "toggle")
    if GI.SHOWWHENTOGGLE then
        GI.gim:ShowFromCursor(x0, y0)
    end
end
GI.ToggleUp = function ()
    GI.breakFlag = true
    local keyindex = GI.index
    --print("keyindex =",keyindex)
    if keyindex == -1 then
        if GI.old_index == nil or GI.old_index == 0 then return end
        keyindex = GI.old_index
    end
    if keyindex == 0 then return end
    local inv = _G.ThePlayer.replica.inventory

    local item = GI.DATA[GI.SESSION][keyindex]

    if item and type(item) ~= "string" and not GI.BOUNDBYNAME then
        inv:UseItemFromInvTile(item)
        GI.UpdateOldIndex(item, keyindex)
        return
    end
    if item and type(item) == "string" and GI.BOUNDBYNAME then
        
        if GI.TryUseItem(item, keyindex, GI.EXCHANGE) then
            return 
        end
        math.randomseed(math.floor(_G.ThePlayer:GetTimeAlive()))
        math.random(5) math.random(5) math.random(5)
        local ran = math.random(5)
        --print(ran)
        local disname = GI.DATA["DisName"][item] or item
        local canb = GI.CanBuild(_G.ThePlayer, item)
        local skin = GI.DATA["SKIN"][item]
        if GI.AUTOCRAFT then
            if canb then
                _G.ThePlayer.components.talker:Say(string.gsub(GI.Speech.TryMake[ran], "#", disname), 3)
                _G.ThePlayer.replica.builder:MakeRecipeFromMenu(_G.AllRecipes[item], skin)
                GI.waitingitemname = item
                GI.keyindex = keyindex
                local function useCraftedItem(inst, data)
                    if data and data.item then
                        if data.item.prefab == GI.waitingitemname then
                            inst:DoTaskInTime(.2, function (inst)
                                inst.replica.inventory:UseItemFromInvTile(data.item)
                                GI.UpdateOldIndex(data.item, GI.keyindex)
                            end)
                        end
                    end
                end
                _G.ThePlayer:ListenForEvent("itemget", useCraftedItem)
                _G.ThePlayer:DoTaskInTime(2, function(inst)
                    inst:RemoveEventCallback("itemget", useCraftedItem)
                end)
            else
                _G.ThePlayer.components.talker:Say(string.gsub(GI.Speech.CantMake[ran], "#", disname), 3)
            end
        else
            _G.ThePlayer.components.talker:Say(string.gsub(GI.Speech.CantFind[ran], "#", disname), 3)
        end
    end
end
GI.BoundDown = function ()
    GI.SESSION = GI.MEMORYALL and "MemoryAll" or _G.TheWorld.meta.session_identifier
    GI.Init(GI.SESSION)

    local x0, y0 = TheInputProxy:GetOSCursorPos()
    GI.gim:HideAll()
    GI.breakFlag = false
    GI.UpdataCursor(x0, y0, "bound")
    --if GI.SHOWWHENTOGGLE then
    GI.gim:ShowFromCursor(x0, y0)
    --end
end
GI.BoundUp = function ()
    GI.breakFlag = true
    local keyindex = GI.index
    if keyindex <= 0 then return end
    local inv = _G.ThePlayer.replica.inventory
    local item = inv:GetActiveItem() or nil
    if GI.BOUNDBYNAME then
        if item then
            GI.DATA[GI.SESSION][keyindex] = item.prefab
            GI.DATA["DisName"][item.prefab] = item:GetBasicDisplayName()
            GI.DATA["ATLAS"][item.prefab], GI.DATA["IMAGE"][item.prefab] = GI.GetAtlasAndImg(item)
            GI.DATA["SKIN"][item.prefab] = item:GetSkinName()
        else
            GI.DATA[GI.SESSION][keyindex] = nil
        end
    else
        GI.DATA[GI.SESSION][keyindex] = item
    end
    inv:ReturnActiveItem()
    GI.Save()
end
GI.DPIDown = function ()
    GI.Init()
    local x0, y0 = TheInputProxy:GetOSCursorPos()
    GI.gim:HideAll()
    GI.breakFlag = false
    GI.UpdataCursor(x0, y0, "DPI")
    --if GI.SHOWWHENTOGGLE then
    --GI.gim:ShowFromCursor(x0, y0)
    --end
end
GI.DPIUp = function ()
    GI.breakFlag = true
    local r = GI.r or 0
    if r > 5 then
        GI.DATA["DPI"] = r < 500 and r or 500
        GI.Save()
    end
end
GI.MouseRightDown = function ()
    
end
GI.MouseRightUp = function ()
    
end
